header
lorom

;Custom OW Layer 1 tile Palettes v1.0 by lolcats439
;Enables custom palettes for colors 9-F of palettes 2-7 on the Overworld
;on a per-submap and if-special-world-passed basis


;how to use it
;edit the custom palettes below the SubmapPtr table
;make the color you want in LM's palette editor, then use the SNES RGB value it gives you


;Note: color 7 of palettes 6 and 7 cannot be customised with this patch because they are animated.


!FREESPACE = $168000; change to freespace 
!DefaultLayer1Pal = $00B528 ; ROM address of the default Layer 3 OW border palette (colors 8-F of palettes 0-1)


org $00AD5E               ;\ Hijack code and JSL to custom code
JSL !FREESPACE            ;|
NOP #19                   ;/


org !FREESPACE
SEP #$30                  
LDY $0DB3                 ;\ get current player 
LDA $1F11,y               ;| index to current player's submap
ASL A                     ;| multiply submap index by 3
CLC                       ;| 
ADC $1F11,y               ;/
TAX
LDA $1EEB                 ;\ Only run if special world is passed - Note: the special world level must be 125 for this to work
BPL SpecialWorldNotPassed ;/ 
TXA                       ;\ If special world is passed
CLC                       ;| add 15 to the submap number in A
ADC #$15                  ;|
TAX                       ;/
SpecialWorldNotPassed:
LDA SubmapPtr+2,x         ;\ Store bank byte into $02
STA $02                   ;|
REP #$30                  ;/
LDA SubmapPtr,x           ;\ Store custom palette address into $00
STA $00                   ;/
LDA.w #$0052              ;\ restore old code
STA $04                   ;|
LDA.w #$0006              ;|
STA $06                   ;|
LDA.w #$0005              ;|
STA $08                   ;/

;7 colors, 6 palettes

JSR LoadCustColors


RTL


; Almost identical to LoadColors rom all.log, copied here so it is in the same bank as the custom palettes
LoadCustColors:
LDX $04                   ; load byte offset (first color number * 2) into X
LDY $06                   ; load number of colors into Y
NextColor:
LDA [$00]                 ; load 24-bit pointer to colors into A
STA.w $0703,X             ; Store color into RAM
INC $00                   ; \ add 2 to $00, to get next color to load
INC $00                   ; /
INX                       ; \ add 2 to X, to offset the RAM address
INX                       ; /
DEY                       ; \ subtract 1 from Y, to decrease remaining color count
BPL NextColor             ; / if Y is still positive, branch up to load next color
LDA $04                   ; after all colors loaded into this row, load RAM offset into A
CLC                       ; \ add 20 to it to move the RAM offset hex 10 colors forward
ADC.w #$0020              ; /
STA $04                   ; store offset to $04 again
DEC $08                   ; \ decrease number of rows to load
BPL LoadCustColors        ; / if $08 is still positive, branch to LoadColors to load colors into the next row
RTS                       ; Return 




;Submap pointer
;1st row is for each submap before special world is passed, 2nd row is after
;The order is MainOW, YoshisIsland, VanillaDome, ForestOfIllution, ValleyOfBowser, SpecialWorld, StarWorld
;Replace "!DefaultLayer1Pal" with the label of the custom palette that you want for that submap
SubmapPtr:
dl !DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal
dl !DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal,!DefaultLayer1Pal


;first color is color 9 of palette 2
MainOW:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
YoshisIsland:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
VanillaDome:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
ForestOfIllusion:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
ValleyOfBowser:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
SpecialWorld:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
StarWorld:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1

MainOWSWP:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
YoshisIslandSWP:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
VanillaDomeSWP:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
ForestOfIllusionSWP:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
ValleyOfBowserSWP:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
SpecialWorldSWP:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1
StarWorldSWP:
dw $0000,$2CE7,$3D6B,$4DEF,$5E73,$6EF7,$7FFF
dw $7FF1,$01BF,$7E00,$03BF,$03E0,$7FFC,$7FFF
dw $0000,$194F,$3E78,$573E,$7E20,$7EE0,$7FE0
dw $0000,$5231,$66F6,$7B9C,$1685,$2F4B,$47F1
dw $0000,$194F,$3E78,$573E,$0000,$7BDE,$7C1F
dw $0000,$194F,$3E78,$573E,$0000,$2F4B,$47F1

